var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var pointerReg = /^#\//;
    var variableReg = /^\$\//;
    function isPointer(s) {
        return typeof s === 'string' && pointerReg.test(s);
    }
    exports.isPointer = isPointer;
    function isVariable(s) {
        return typeof s === 'string' && variableReg.test(s);
    }
    exports.isVariable = isVariable;
    function isMustache(s) {
        return typeof s === 'string' && /{{\s*#\/.+?(?=}})/.test(s);
    }
    exports.isMustache = isMustache;
    function getPath(str) {
        var path = str.replace(pointerReg, '').split('/').filter(function (a) { return a; });
        return path;
    }
    exports.getPath = getPath;
    function getVariable(str) {
        return str.replace(variableReg, '');
    }
    exports.getVariable = getVariable;
    function getFromPath(str, parentPath) {
        var path = getPath(str);
        var isRoot = false;
        if (path[0] === '~') {
            isRoot = true;
            path = path.slice(1);
        }
        return {
            path: path,
            parentPath: parentPath ? (isRoot ? __assign({}, parentPath, { from: [] }) : __assign({}, parentPath)) : parentPath
        };
    }
    exports.getFromPath = getFromPath;
});
//# sourceMappingURL=utils.js.map